% METODO DE OPTIMIZACION POR MULTIPLICADORES DE LAGRANGE
%
% Optimizar la funcion no lineal F(X), dada una
% aproximacion inicial X:
%
% ENTRADA: Numero de variables de la ecuacion N; aproximacion inicial
%          X=(X(1),...,X(n)); tolerancia h; numero de 
%          restricciones N; numero de iteraciones NN.
%
% SALIDA:  Solucion aproximada X=(X(1),...,X(n)) o un mensaje
%          de que el numero de iteraciones fue sobrepasado.
 syms('OK', 'N', 'I', 'J', 'P', 'h', 'NN', 'X','ZZ', 'g', 'q', 'F','FF','RR');
 syms('FLAG', 'NAME', 'OUP', 'K', 'A', 'R', 's', 'ss', 'Res', 'fs', 'f','Q','T');
 syms('K1', 'I1', 'Z1', 'IR1', 'IA1', 'J1', 'C1', 'L1', 'JA1', 'EP','EE','BB');
 TRUE = 1;
 FALSE = 0;
 fprintf(1,'Este es el metodo de Optimizacion funciones no lineales por Multiplicadores de Lagrange.\n');
 fprintf(1,'La funcion y las restricciones pueden ser escritas ahora o leidas de un fichero.\n');
 fprintf(1,'El numero de variables de la funcion no puede exceder de 5.\n');
 fprintf(1,'En otro caso habria que modificar el programa.\n');
 
 OK = FALSE;
 while OK == FALSE
    fprintf(1,'Escriba el numero de variables N.\n');
    N = input(' ');
    if N <= 5
        OK = TRUE;
    else
        fprintf(1,'El numero de variables N debe ser un entero menor que 6.\n');
    end;
 end;
 OK = FALSE;
 while OK == FALSE
    fprintf(1,'Escriba el numero de restricciones M.\n');
    M = input(' ');
    if M <= N-1
        OK = TRUE;
    else
        fprintf(1,'El numero de restricciones M debe ser un entero menor que el numero de variables N.\n');
    end;
 end;
 A = zeros(N+M,N+M+1);
 X = zeros(1,N+M);
 Y = zeros(1,N+M);
 FF = zeros (1,N+M);
 fprintf(1,'Entrada de la funcion\n');
 fprintf(1,'1. Pantalla\n');
 fprintf(1,'2. Fichero de texto\n');
 fprintf(1,'Escriba 1 o 2\n');
 BB = input(' ');
 if BB == 2  
    fprintf(1,'Escriba el nombre del fichero en la forma - disco:\\nombre.ext\n');
    fprintf(1,'Por ejemplo:   A:\\DATA.DTA\n');
    NAME = input(' ','s');
    INP = fopen(NAME,'rt');
     
    f = fscanf(INP,'%s',1);
        
        for I = 1 : M
                Res(I) = fscanf(INP,'%s',1);
        end;
        
        for I = 1 : M+N
                X(I) = fscanf(INP,'%f',1);
        end;
        
    fclose(INP);
 
 else 
        
        fprintf(1,'Escriba la funcion F en terminos de y1 ... y%d \n',N);
        f = input(' ','s');
        
        for I = 1 : M
            fprintf(1,'Escriba la restriccion Res(%d) igualada a cero (solo el primer miembro)\n',I);
            fprintf(1,'en terminos de y1, ..., y%d \n',N);

            Res(I) = input(' ','s');
        end;
     
        for I = 1 : M+N
            
                fprintf(1,'Escriba la aproximacion inicial X(%d)\n',I);
                X(I) = input(' ');
        end;
 end;
     OK = FALSE;
    while OK == FALSE
        fprintf(1,'Escriba la tolerancia T.\n');
        T = input(' ');
        if T > 0
            OK = TRUE;
        else
            fprintf(1,'La tolerancia T debe ser positiva.\n');
        end;
    end;
    OK = FALSE;
    while OK == FALSE
        fprintf(1,'Escriba el numero maximo de iteraciones NN.\n');
        NN = input(' ');
        if NN > 0
            OK = TRUE;
        else
            fprintf(1,'El numero maximo de iteraciones NN debe ser un entero positivo.\n');
        end;
    end;
                
    EP = zeros(1,NN);
    fprintf(1,'Salida de datos\n');
    fprintf(1,'1. Pantalla\n');
    fprintf(1,'2. Fichero de texto\n');
    fprintf(1,'Escriba 1 o 2\n');
    FLAG = input(' ');
    if FLAG == 2
        fprintf(1,'Escriba el nombre del fichero de la forma - disco\\:nombre.ext\n');
        fprintf(1,'Por ejemplo   A:\\OUTPUT.DTA\n');
        NAME = input(' ','s');
        OUP = fopen(NAME,'wt');
    else
        OUP = 1;
    end;
    fprintf(1,'Seleccione la cantidad de resultados que desea visualizar\n');
    fprintf(1,'1. Solo la respuesta \n');
    fprintf(1,'2. Todas las aproximaciones intermedias\n');
    fprintf(1,'Escriba 1 o 2\n');
    FLAG = input(' ');
    fprintf(OUP, 'METODO DE OPTIMIZACION POR MULTIPLICADORES DE LAGRANGE\n\n');
    if FLAG == 2
        fprintf(OUP, 'Iteracion, Aproximacion, Error\n');
    end;
           
% PASO 1
    OK = TRUE;
    K = 1;
    h = 1e-4;
% PASO 2
    while OK == TRUE & K <= NN
        A = zeros(N+M,N+M+1);
        FF = zeros (1,N+M);
% PASO 3
%        if K == 1
                for I = 1 : N+M
                    
                    for J = 1 : N+M
                        
                        if N == 2
                            
                            if I == J
                                
                                if I <=N
                                    q = inline(char(f),'y1','y2');
                                    X(I) = X(I)+h;
                                    A(I,J) = q(X(1),X(2));
                                    X(I) = X(I)-2*h;
                                    EE = q(X(1),X(2));
                                    A(I,J) = A(I,J)+EE;
                                    X(I) = X(I)+h;
                                    EE = q(X(1),X(2));
                                    A(I,J) = (A(I,J)-2*EE)/(h^2);
                                end;
                   
                                for Q = 1 : M
                        
                                    q = inline(char(Res(Q)),'y1','y2');
                                    X(I) = X(I)+h;
                                    RR = q(X(1),X(2));
                                    RR = X(N+Q)*RR;
                                    X(I) = X(I)-2*h;
                                    EE = q(X(1),X(2));
                                    EE = X(N+Q)*EE;
                                    X(I) = X(I)+h;
                                    A(I,J) = A(I,J) + ((RR + EE)/(h^2));
                                    EE = q(X(1),X(2));
                                    EE = X(N+Q)*EE;
                                    A(I,J) = A(I,J) - (2*EE/(h^2));
                    
                                end;
                        
                            else
                                if I<=N & J<=N
                                    
                                    
                                    q = inline(char(f),'y1','y2');
                                    EE = q(X(1),X(2));
                                    A(I,J) = -2*EE;
                                    X(I) = X(I)+h;
                                    EE = q(X(1),X(2));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J)+h;
                                    EE = q(X(1),X(2));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) - 2*h;
                                    EE = q(X(1),X(2));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I) - h;
                                    EE = q(X(1),X(2));
                                    A(I,J) = A(I,J) + EE;
                                    X(I) = X(I) - h;
                                    EE = q(X(1),X(2));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = q(X(1),X(2));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = q(X(1),X(2));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I)+ h;
                                    EE = q(X(1),X(2));
                                    A(I,J) = (A(I,J) + EE)/(6*(h^2));
                                    X(J)=X(J)-h;
                                end;
                                
                                for Q = 1 : M
                                    
                                    
                                    q = inline(char(Res(Q)),'y1','y2');
                                    EE = X(N+Q)*q(X(1),X(2));
                                    A(I,J) = A(I,J)*(6*(h^2))-2*EE;
                                    X(I) = X(I)+h;
                                    EE = X(N+Q)*q(X(1),X(2));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J)+h;
                                    EE = X(N+Q)*q(X(1),X(2));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) - 2*h;
                                    EE = X(N+Q)*q(X(1),X(2));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I) - h;
                                    EE = X(N+Q)*q(X(1),X(2));
                                    A(I,J) = A(I,J) + EE;
                                    X(I) = X(I) - h;
                                    EE = X(N+Q)*q(X(1),X(2));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = X(N+Q)*q(X(1),X(2));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = X(N+Q)*q(X(1),X(2));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I)+ h;
                                    EE = X(N+Q)*q(X(1),X(2));
                                    A(I,J) = (A(I,J) + EE)/(6*(h^2));        
                                    X(J)=X(J)-h;
                                end;
                            end;
                                                    
                        elseif N  ==  3            
                        
                            if I == J
                                if I<=N
                                    q = inline(char(f),'y1','y2','y3');
                                    X(I) = X(I)+h;
                                    A(I,J) = q(X(1),X(2),X(3));
                                    X(I) = X(I)-2*h;
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J)+EE;
                                    X(I) = X(I)+h;
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J)-2*EE;
                                end;
                    
                                for Q = 1 : M
                        
                                    q = inline(char(Res(Q)),'y1','y2','y3');
                                    X(I) = X(I)+h;
                                    RR = q(X(1),X(2),X(3));
                                    RR = X(N+Q)*RR;
                                    X(I) = X(I)-2*h;
                                    EE = q(X(1),X(2),X(3));
                                    EE = X(N+Q)*EE;
                                    X(I) = X(I)+h;
                                    A(I,J) = A(I,J) + RR + EE;
                                    EE = q(X(1),X(2),X(3));
                                    EE = X(N+Q)*EE;
                                    A(I,J) = (A(I,J) - 2*EE)/(h^2);
                    
                                end;
                        
                            else
                                if I<=N & J<=N
                                    q = inline(char(f),'y1','y2','y3');
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = -2*EE;
                                    X(I) = X(I)+h;
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J)+h;
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) - 2*h;
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I) - h;
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) + EE;
                                    X(I) = X(I) - h;
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I)+ h;
                                    EE = q(X(1),X(2),X(3));
                                    A(I,J) = (A(I,J) + EE)/(6*(h^2));
                                    X(J)=X(J)-h;
                                end;
                    
                                for Q = 1 : M
                        
                                    q = inline(char(Res(Q)),'y1','y2','y3');
                                    EE = X(N+Q)*q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J)*(6*(h^2))-2*EE;
                                    X(I) = X(I)+h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J)+h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) - 2*h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I) - h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) + EE;
                                    X(I) = X(I) - h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I)+ h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3));
                                    A(I,J) = (A(I,J) + EE)/(6*(h^2)); 
                                    X(J)=X(J)-h;
                    
                                end;
                                
                                 
                    
                            end;
                
                        elseif N == 4
        
                            if I == J
                                if I <=N                    
                                    q = inline(char(f),'y1','y2','y3','y4');
                                    X(I) = X(I)+h;
                                    A(I,J) = q(X(1),X(2),X(3),X(4));
                                    X(I) = X(I)-2*h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J)+EE;
                                    X(I) = X(I)+h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = (A(I,J)-2*EE)/(h^2);
                                end;
                    
                                for Q = 1 : M
                        
                                    q = inline(char(Res(Q)),'y1','y2','y3','y4');
                                    X(I) = X(I)+h;
                                    RR = q(X(1),X(2),X(3),X(4));
                                    RR = X(N+Q)*RR;
                                    X(I) = X(I)-2*h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    EE = X(N+Q)*EE;
                                    X(I) = X(I)+h;
                                    A(I,J) = A(I,J) + (RR + EE)/(h^2);
                                    EE = q(X(1),X(2),X(3),X(4));
                                    EE = X(N+Q)*EE;
                                    A(I,J) = A(I,J) - 2*(EE/(h^2));
                    
                                end;
                        
                            else
                                if I<=N & J<=N
                                    q = inline(char(f),'y1','y2','y3','y4');
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = -2*EE;
                                    X(I) = X(I)+h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J)+h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) - 2*h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I) - h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) + EE;
                                    X(I) = X(I) - h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I)+ h;
                                    EE = q(X(1),X(2),X(3),X(4));
                                    A(I,J) = (A(I,J) + EE)/(6*(h^2));
                                    X(J)=X(J)-h;
                                end;
                    
                                for Q = 1 : M
                        
                                    q = inline(char(Res(Q)),'y1','y2','y3','y4');
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J)*(6*(h^2))-2*EE;
                                    X(I) = X(I)+h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J)+h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) - 2*h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I) - h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) + EE;
                                    X(I) = X(I) - h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I)+ h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4));
                                    A(I,J) = (A(I,J) + EE)/(6*(h^2));    
                                    X(J)=X(J)-h;
                    
                                end;
                                
                                 
                    
                            end;
                
        
                        else
        
                            if I == J
                                if I<=N
                                    q = inline(char(f),'y1','y2','y3','y4','y5');
                                    X(I) = X(I)+h;
                                    A(I,J) = q(X(1),X(2),X(3),X(4),X(5));
                                    X(I) = X(I)-2*h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J)+EE;
                                    X(I) = X(I)+h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = (A(I,J)-2*EE)/(h^2);
                                end;
                    
                                for Q = 1 : M
                        
                                    q = inline(char(Res(Q)),'y1','y2','y3','y4','y5');
                                    X(I) = X(I)+h;
                                    RR = q(X(1),X(2),X(3),X(4),X(5));
                                    RR = X(N+Q)*RR;
                                    X(I) = X(I)-2*h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    EE = X(N+Q)*EE;
                                    X(I) = X(I)+h;
                                    A(I,J) = A(I,J) + (RR + EE)/(h^2);
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    EE = X(N+Q)*EE;
                                    A(I,J) = A(I,J) - 2*(EE/(h^2));
                    
                                end;
                        
                            else
                                if I<=N & J<=N
                                    q = inline(char(f),'y1','y2','y3','y4','y5');
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = -2*EE;
                                    X(I) = X(I)+h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J)+h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) - 2*h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I) - h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) + EE;
                                    X(I) = X(I) - h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I)+ h;
                                    EE = q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = (A(I,J) + EE)/(6*(h^2));
                                    X(J)=X(J)-h;
                                end;
                    
                                for Q = 1 : M
                        
                                    q = inline(char(Res(Q)),'y1','y2','y3','y4','y5');
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J)*(6*(h^2))-2*EE;
                                    X(I) = X(I)+h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J)+h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) - 2*h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I) - h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) + EE;
                                    X(I) = X(I) - h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) + EE;
                                    X(J) = X(J) + h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = A(I,J) -2*EE;
                                    X(I) = X(I)+ h;
                                    EE = X(N+Q)*q(X(1),X(2),X(3),X(4),X(5));
                                    A(I,J) = (A(I,J) + EE)/(6*(h^2));    
                                    X(J)=X(J)-h;

                                end;
                                
                            end;
                
                        end;
                        
                    end;
                    
                end;       
                
    %    end;
        
    if N == 2
        
        for I = 1 : N
            
            q = inline(char(f),'y1','y2');
            X(I) = X(I)+h;
            FF(I) = q(X(1),X(2));
            X(I) = X(I)-2*h;
            EE = q(X(1),X(2));
            X(I) = X(I)+h;
            FF(I) = (FF(I) - EE)/(2*h);
        end;
        
        for J = 1 : M
            
            for I = 1 : N+M
                
                q = inline(char(Res(J)),'y1','y2');
                X(I) = X(I)+h;
                RR = q(X(1),X(2));
                RR = X(N+J)*RR;
                X(I) = X(I)-2*h;
                EE = q(X(1),X(2));
                EE = X(N+J)*EE;
                X(I) = X(I)+h;
                FF(I) = FF(I) + (RR - EE)/(2*h);
                                    
            end;
        end;
        
    elseif N  ==  3
        
        for I = 1 : N
            
            q = inline(char(f),'y1','y2','y3');
            X(I) = X(I)+h;
            FF(I) = q(X(1),X(2),X(3));
            X(I) = X(I)-2*h;
            EE = q(X(1),X(2),X(3));
            X(I) = X(I)+h;
            FF(I) = (FF(I) - EE)/(2*h);
        end;
        
        for J = 1 : M
            
            for I = 1 : N+M
                
                q = inline(char(Res(J)),'y1','y2','y3');
                X(I) = X(I)+h;
                RR = q(X(1),X(2),X(3));
                RR = X(N+J)*RR;
                X(I) = X(I)-2*h;
                EE = q(X(1),X(2),X(3));
                EE = X(N+J)*EE;
                X(I) = X(I)+h;
                FF(I) = FF(I) + (RR - EE)/(2*h);
                    
            end;
        end;
        
    elseif N == 4
        
        for I = 1 : N
            
            q = inline(char(f),'y1','y2','y3','y4');
            X(I) = X(I)+h;
            FF(I) = q(X(1),X(2),X(3),X(4));
            X(I) = X(I)-2*h;
            EE = q(X(1),X(2),X(3),X(4));
            X(I) = X(I)+h;
            FF(I) = (FF(I) - EE)/(2*h);
        end;
        
        for J = 1 : M
            
            for I = 1 : N+M
                
                q = inline(char(Res(J)),'y1','y2','y3','y4');
                X(I) = X(I)+h;
                RR = q(X(1),X(2),X(3),X(4));
                RR = X(N+J)*RR;
                X(I) = X(I)-2*h;
                EE = q(X(1),X(2),X(3),X(4));
                EE = X(N+J)*EE;
                X(I) = X(I)+h;
                FF(I) = FF(I) + (RR - EE)/(2*h);
                    
            end;
        end;
        
    else 
        
        for I = 1 : N
            
            q = inline(char(f),'y1','y2','y3','y4','y5');
            X(I) = X(I)+h;
            FF(I) = q(X(1),X(2),X(3),X(4),X(5));
            X(I) = X(I)-2*h;
            EE = q(X(1),X(2),X(3),X(4),X(5));
            X(I) = X(I)+h;
            FF(I) = (FF(I) - EE)/(2*h);
        end;
        
        for J = 1 : M
            
            for I = 1 : N+M
                
                q = inline(char(Res(J)),'y1','y2','y3','y4','y5');
                X(I) = X(I)+h;
                RR = q(X(1),X(2),X(3),X(4),X(5));
                RR = X(N+J)*RR;
                X(I) = X(I)-2*h;
                EE = q(X(1),X(2),X(3),X(4),X(5));
                EE = X(N+J)*EE;
                X(I) = X(I)+h;
                FF(I) = FF(I) + (RR - EE)/(2*h);
                    
            end;
        end;
    end;
        
    for I = 1 : N+M
        
            A(I,N+M+1) = -FF(I);
            
    end;
          if K==1
            R = 0;
            for I = 1 : N+M
                if abs(FF(I)) > R
                    R = abs(FF(I));
                end;
            end;
            EP(K)=R;
            if FLAG == 2
                fprintf(OUP, ' %2d', K-1);
                for I = 1 : N+M
                    fprintf(OUP, ' %11.8f', X(I));
                end;
                fprintf(OUP, '\n%12.6e\n', R);
            end;
          end;
          
% PASO 4
        K1 = N+M-1;
        OK = TRUE;
        I1 = 1;
        while OK == TRUE & I1 <= K1
            Z1 = abs(A(I1,I1));
            IR1 = I1;
            IA1 = I1+1;
            for J1 = IA1 : N+M
                if abs(A(J1,I1)) > Z1
                    IR1 = J1;
                    Z1 = abs(A(J1,I1));
                end;
            end;
            
            if Z1 <= 1.0e-20
                OK = FALSE;
            else
                if IR1 ~= I1
                    for J1 = I1 : N+M+1
                        C1 = A(I1,J1);
                        A(I1,J1) = A(IR1,J1);
                        A(IR1,J1) = C1;
                    end;
                end;
                for J1 = IA1 : N+M
                    C1 = A(J1,I1)/A(I1,I1);
                    if abs(C1) <= 1.0e-20
                        C1 = 0;
                    end;
                    for L1 = I1 : N+M+1
                        A(J1,L1) = A(J1,L1)-C1*A(I1,L1);
                    end;
                end;
            end;
            I1 = I1+1;
        end;
        
        if OK == TRUE
            if abs(A(N+M,N+M)) <= 1.0e-20
                OK = FALSE;
            else
                Y(N+M) = A(N+M,N+M+1)/A(N+M,N+M);
                for I1 = 1 : K1
                    J1 = N+M-I1;
                    JA1 = J1+1;
                    C1 = A(J1,N+M+1);
                    for L1 = JA1 : N+M
                        C1 = C1-A(J1,L1)*Y(L1);
                    end;
                    Y(J1) = C1/A(J1,J1);
                end;
            end;
        end;
        if OK == FALSE
            fprintf(1,'El sistema lineal es singular\n');
        end;
        
        if OK == TRUE
% PASO 5
            R = 0;
            for I = 1 : N+M
                if abs(Y(I)) > R
                    R = abs(Y(I));
                end;
                X(I) = X(I)+Y(I);
            end;            
            EP(K)=R;
            if FLAG == 2
                fprintf(OUP, ' %2d', K);
                for I = 1 : N+M
                    fprintf(OUP, ' %11.8f', X(I));
                end;
                fprintf(OUP, '\n%12.6e\n', R);
            end;
            
% PASO 6
            if R <= T
                OK = FALSE;
                fprintf(OUP, 'La solucion en la iteracion %d es:\n\n', K);
                for I = 1 : N+M
                    fprintf(OUP, ' %11.8f', X(I));
                end;
                fprintf(OUP, '\n\n con una tolerancia %.10e\n', T);
% PASO 7
            else
                K = K+1;
            end;
           
        end;
        
    end;
    T=0;
    if K>NN
        T=K;
        K=NN;
    end;
    EP=EP(1:K);
    figure(1);
    semilogy(EP,'--rs','LineWidth',2,'MarkerEdgeColor','k','MarkerFaceColor','g','MarkerSize',5);
    title('METODO DE NEWTON-RAPHSON');
    xlabel('Iteraciones'); 
    ylabel('Error');
    if T > NN
% PASO 8
        fprintf(OUP, 'El proceso no converge en %d iteraciones\n', NN);
    end;
    if OUP ~= 1
        fclose(OUP);
        fprintf(1,'Fichero de salida %s creado satisfactoriamente \n',NAME);
    end;